/* -------------------------- Qu'est ce que Transact-SQL?
Transact-SQL (ou encore appel  T-SQL) est un langage de programmation procdural  database. Il est le monopole de Microsoft, qui est utilis dans  SQL Server. 

Les langages de procdure sont conus pour tendre les capacits de SQL tout en permettant de bien intgrer SQL. Plusieurs fonctionnalits telles que les variables locales et le traitement des chanes / donnes sont ajoutes. Ces fonctionnalits rendent la langue Transact-SQL est Turing-complete. 

Ils sont galement utiliss pour crire des procdures stockes: des extraits de code rsidant sur le serveur pour grer des rgles commerciales complexes qui sont difficiles ou impossibles  grer avec des oprations bases sur des ensembles purs (pure set-based operations). 

 ---------------------------- L'aperu de Transact-SQL
T-SQL est organis par chaque bloc de dclaration. Un bloc de dclaration peut embrasser un autre bloc de dclaration. Un bloc de dclaration commence par BEGIN et finit par END. Il existe de nombreuses dclarations dans le bloc, et les dclarations sont spares l'une de l'autre par un point-virgule (;).
La structure du boc:


BEGIN
    -- Declare variables
    -- T-SQL Statements
END;

Dclarations simples !!!
----------------------------------------------- BEGIN ... END---------------------------------------------
 */
Begin
 
  -- Declaring a variable
  Declare @v_Result Int;
  -- Declaring a variable with a value of 50
  Declare @v_a Int = 50;
  -- Declaring a variable with a value of 100
  Declare @v_b Int = 100;
 
 
  -- Print out Console (For developer).
  -- Using Cast to convert Int to String
  -- Using + operator to concatenate 2 string
  Print 'v_a= ' + Cast(@v_a as varchar(15));
 
  -- Print out Console
  Print 'v_b= ' + Cast(@v_b as varchar(15));
 
  -- Sum
  Set @v_Result = @v_a + @v_b;
 
  -- Print out Console
 Print 'v_Result= ' + Cast(@v_Result as varchar(15));
 
End;

/*
---------------------------------------------La commande du marquage If-elsif-else --------------------------------

IF <condition 1> THEN
    Job 1;
[ELSIF <condition 2> THEN
     Job 2;
]
[ELSE
     Job n + 1;
]
END IF;

-----------------------------------------------------------------------------------------------------------------------
*/
BEGIN
 
 -- Declare a variable
 DECLARE @v_Option integer;
 DECLARE @v_Action varchar(30);
 
 SET @v_Option = 2;
 
 IF @v_Option = 1
   SET @v_Action = 'Run';
 ELSE IF @v_Option = 2
     BEGIN
       PRINT 'In block else if @v_Option = 2';
       SET @v_Action = 'Backup';
     END;
 ELSE IF @v_Option = 3
   SET @v_Action = 'Stop';
 ELSE
   SET @v_Action = 'Invalid';
 
 
 -- Logging
 PRINT '@v_Action= ' + @v_Action;
 
END; /*

-------------------------------------------- While_Example1 ---------------------------------------------------------
LA BOUCLE WHILE 

LOOP
 -- Do something here
EXIT WHEN <Condition>;
END LOOP;

*/
BEGIN
 
 -- Declaring 2 variables x and y.
 DECLARE @x integer = 0;
 DECLARE @y integer = 10;
 
 -- Step
 DECLARE @step integer = 0;
 
 -- While @x < @y
 WHILE (@x < @y)
 BEGIN
 
   SET @step = @step + 1;
 
   -- Every time loop execute, x increases by 1.
   SET @x = @x + 1;
   -- Every time loop execute, x decreases by 2.
   SET @y = @y - 2;
 
   PRINT 'Step =' + CAST(@step AS varchar(10));
   PRINT '@x =' + CAST(@x AS varchar(10)) + ' / @y = ' + CAST(@y AS varchar(10));
 
 END;
 
 -- Write log
 PRINT 'x,y = ' + CAST(@x AS varchar(10)) + ', ' + CAST(@y AS varchar(10));
 
END;

----------------------------------------------------------------------------------------------------------------
-- BREAK??????? est la dclaration permettant de sortir de la boucle. Voici un exemple:

------------------------------------------------------- While_Example2 ----------------------------------------

BEGIN
 
 -- Declaring 2 variables x and y
 DECLARE @x integer = 0;
 DECLARE @y integer = 10;
 
 -- Step
 DECLARE @step integer = 0;
 
 -- While @x < @y
 WHILE (@x < @y)
 BEGIN
 
   SET @step = @step + 1;
 
   -- Every time the loop execute, x increases by 1
   SET @x = @x + 1;
   -- Every time the loop execute, y decreases by 1
   SET @y = @y - 2;
 
   PRINT 'Step =' + CAST(@step AS varchar(10));
   PRINT '@x =' + CAST(@x AS varchar(10)) + ' / @y = ' + CAST(@y AS varchar(10));
 
   -- If @x > 2 then exit the loop
   -- (Although conditions in the WHILE is still true).
   IF @x > 2
     BREAK;
 
 END;
 
 -- Write log
 PRINT 'x,y = ' + CAST(@x AS varchar(10)) + ', ' + CAST(@y AS varchar(10));
 
END;

--------------------------------------------------------------------------------------------------------------------
-- La dclaration  CONTINUE permet d'ignorer les instructions ci-dessous (en boucle) afin de continuer une nouvelle boucle.
--------------------------------------------------- While_Example3        ------------------------------------------
BEGIN
 
 -- Declaring 2 variables x and y.
 DECLARE @x integer = 0;
 DECLARE @y integer = 10;
 
 -- Step
 DECLARE @step integer = 0;
 
 -- While @x < @y
 WHILE (@x < @y)
 BEGIN
 
   SET @step = @step + 1;
 
   -- Every time the loop execute, x increases by 1
   SET @x = @x + 1;
   -- Every time the loop execute, x decreases by 2
   SET @y = @y - 2;
 
   -- If @x < 3 , then skip the statements below
   -- And continue new step
   IF @x < 3
     CONTINUE;
 
   -- If @x < 3 the statements below 'CONTINUE' will not be run.
   PRINT 'Step =' + CAST(@step AS varchar(10));
   PRINT '@x =' + CAST(@x AS varchar(10)) + ' / @y = ' + CAST(@y AS varchar(10));
 
 END;
 
 -- Write log
 PRINT 'x,y = ' + CAST(@x AS varchar(10)) + ', ' + CAST(@y AS varchar(10));
 
END;

-------------------------------------------------------------
----- Contraintes d'intgrit

use SAMPLE_DATABASE2

-- supprimer la contrainte
alter table Countries NOCHECK CONSTRAINT FK__countries__regio__3B75D760

-- si plusieurs 
ALTER TABLE MaTable NOCHECK CONSTRAINT all

-- supprimer la contrainte au niveau de la cl trangre
alter table Countries
	drop FK__countries__regio__3B75D760

-- supprimer la colonne region_id
alter table Countries
	drop column region_id

ALTER TABLE MaTable NOCHECK CONSTRAINT MaContrainte

-- Modifier valeurs d'une cl trangre
use Sample_database

update locations
SET country_id= '3'
where location_id = 2

select * from locations