---- Exercices - partie perf -------------

----------  CREATE  ------------------

CREATE DATABASE SAMPLE_DATABASE2
uSE SAMPLE_DATABASE2

-- dmo
CREATE TABLE regions (
	region_id INT IDENTITY(1,1) PRIMARY KEY,
	region_name VARCHAR (25) DEFAULT NULL
);

/* Default : Indique que si aucune valeur n'est fournie, 
le serveur de SGBD insre 0 pour les colonnes numriques et montaires, 
une chane vide pour les colonnes de caractres, 
la date actuelle pour les colonnes de date ANSI.*/

CREATE TABLE countries (
	country_id CHAR (2) PRIMARY KEY,
	country_name VARCHAR (40) DEFAULT NULL,
	region_id INT NOT NULL,
	FOREIGN KEY (region_id) REFERENCES regions (region_id)
);

-- 1. Exercices stagiaires :
/* Cration d'une table locations avec 6 colonnes :
- location_id de type integer et PK sur laquelle on n'autorise pas les null,
- street_address de type VARCHAR max 40 caractres,
- postal_code de type VARCHAR max 12 caractres,
- city de type VARCHAR max 30 caractres sur laquelle on n'autorise pas les null,
- state_province de type VARCHAR max 25 caractres,
- country_id CHAR max 2 caractres sur laquelle on n'autorise pas les null
Country_id est une cl trangre faisant rfrence  la cl primaire country_id dans la table countries
*/

CREATE TABLE locations (
	location_id INT IDENTITY(1,1) PRIMARY KEY,
	street_address VARCHAR (40) DEFAULT NULL,
	postal_code VARCHAR (12) DEFAULT NULL,
	city VARCHAR (30) NOT NULL,
	state_province VARCHAR (25) DEFAULT NULL,
	country_id CHAR (2) NOT NULL,
	FOREIGN KEY (country_id) REFERENCES countries (country_id) 
);

-- 2. Exercices stagiaires :
/* Cration d'une table jobs avec 4 colonnes :
- job_id de type integer et PK sur laquelle on n'autorise pas les null,
- job_title de type VARCHAR max 35 caractres sur laquelle on n'autorise pas les null,
- min_salary de type Decimal(8,2),
- max_salary de type Decimal(8,2)
*/

CREATE TABLE jobs (
	job_id INT IDENTITY(1,1) PRIMARY KEY,
	job_title VARCHAR (35) NOT NULL,
	min_salary DECIMAL (8, 2) DEFAULT NULL,
	max_salary DECIMAL (8, 2) DEFAULT NULL
);

-- OOPS il me manque plusieurs colonnes ! Dmo - rajout de departement et ville dans table regions
ALTER TABLE regions
ADD dep VARCHAR(25) NULL,
	 ville VARCHAR(25) NULL

-- 3. Exercices stagiaires : rajouter la colonne dateentree sur table JOB
ALTER TABLE jobs
ADD dateentree Date NULL

---------------------------     INSERT ------------------
use Sample_database2

SET IDENTITY_INSERT regions ON -- si besoin

-- Dmo - insertion dans la table Regions
INSERT INTO regions(region_id,region_name) VALUES (1,'Europe');
INSERT INTO regions(region_id,region_name) VALUES (2,'Americas');
INSERT INTO regions(region_id,region_name) VALUES (3,'Asia');
INSERT INTO regions(region_id,region_name) VALUES (4,'Middle East and Africa');

INSERT INTO regions(region_id,region_name) 
VALUES (1,'Europe'),(2,'Americas'),(3,'Asia'),(4,'Middle East and Africa')

-- Si on veut le laisser faire, l'auto-incrmentation : pas besoin ud set identity 
-- Mais il ne faut pas forcer pour remplir l'id qui se fait tout seul

INSERT INTO regions(region_name) 
VALUES ('Europe'),('Americas'),('Asia'),('Middle East and Africa')

-- 4. Exercices stagiaires - Insertion dans la table pays
-- Insrer l'argentine, avec un country-id de AR et une rgion_id de 2
-- Insrer l'Australie, avec un country-id de AU et une rgion_id de 3
-- Insrer la Belgique, avec un country-id de BE et une rgion_id de 1
INSERT INTO countries(country_id,country_name,region_id) VALUES ('AR','Argentina',2);
INSERT INTO countries(country_id,country_name,region_id) VALUES ('AU','Australia',3);
INSERT INTO countries(country_id,country_name,region_id) VALUES ('BE','Belgium',1)

INSERT INTO countries(country_id,country_name,region_id) 
VALUES ('AR','Argentine',2), ('AU','Australie',3),('BE','Belgique',1)

----------------------     UPDATE ------------------
-- exemple : Transformer la valeur Argentine en Argentina
Update countries
SET country_name='Argentina'
where country_name='Argentine'

-- exemple cours : Quand le prix unitaire du produit est infrieur  la moyenne de tous les prix unitaire
-- alors le prix unitaire doit tre augmenter de 10% de plus
use comptoir

UPDATE T_Produit
SET ProduitPU = ProduitPU * 0.9
Where
PRODUITPU < (select avg (ProduitPU) from T_Produit)

-- 5. Exercices stagiaires : 
-- Je veux modifier la ville (Paris  la place de Marseille) 
-- de mon client quand son nom est Bon app'
UPDATE T_Client
SET ClientVille = 'Paris'
where clientnom ='Bon app'' '

-- 6. si le nombre de produits en stock est infrieur  20 alors j'augmente le prix unitaire de 2%
update T_Produit
SET ProduitPU = ProduitPU * 0.02
Where
ProduitUnitsInStock < 20

-- Update -- exemples en plus si perf sur 4 jours ----------------
-- je souhaite rajouter 2 ans sur la date d'entre de mes employs
-- dont le poste estsales representants et habitant aux USA
use comptoir
update T_Employe 
set EmployeDteEntree= DATEADD(yyyy,2,EmployeDteEntree) 
where EmployeTitre='Sales Representative' and EmployePays='USA'

/*Inserer dans table DimProduct les champs Categorie et sub categorie*/
use ContosoRetailDW

UPDATE dbo.DimProduct
SET Category = C.ProductCategoryName, 
		SubCategory = SC.ProductSubcategoryName 
FROM dbo.DimProduct P INNER JOIN dbo.DimProductSubcategory SC 
		ON P.ProductSubcategoryKey = SC.ProductSubcategoryKey 
	INNER JOIN dbo.DimProductCategory C 
		ON SC.ProductCategoryKey = C.ProductCategoryKey 

----------------------     DELETE ------------------
---------  Supprimer les lignes de la table
use comptoir

-- Supprimer les lignes de la table T_employe
delete from T_Employe

-- Supprimer la table t_employe
drop table t_employe

-- 7. Exercice Stagiaires ---------
-- Supprimer les lignes de la table T_fournisseur
delete from T_Fournisseur

-- 8. Supprimer la table fournisseur
drop table T_Fournisseur

------------ Exemples avec IF EXISTS
/*Supprimer cette table (avec condition IF EXISTS)*/ -- + complexe
use AdventureWorks2012

IF EXISTS (SELECT name FROM tempdb.dbo.sysobjects where name like '#CustomerPerson%')
	print('Existe')
ELSE
	print('Existe pas')

IF EXISTS (SELECT name FROM tempdb.dbo.sysobjects where name like '#CustomerPerson%')
	DROP TABLE #CustomerPerson

-- supprimer des colonnes ------------------ Formation 4 jours
-- Je souhaite maintenant supprimer plusieurs colonnes ! DEMO

ALTER TABLE jobs
    DROP COLUMN 
        dateentree

-- Exercices stagiaires : supprimer colonnes
ALTER TABLE regions
    DROP COLUMN 
        dep, ville

------------------------- PROCEDURES STOCKEES  ----------
---------- DEMO exemple sans variable
-- Crer une procdure stocke qui va chercher les clients qui habitent en France
-- pas de paramtre : 31 lignes de rsultats
Use comptoir

Create procedure SP_cltFr
as
select clientnom from T_Client clt 
where ClientPays='France'

Exec SP_cltFr

---------- DEMO 1 critre avec variable sur Pays
Create procedure SP_cltVpays @Pays Varchar(20)
as
select clientnom from T_Client clt 
where ClientPays= @Pays

Exec SP_cltVpays @pays='France'

Exec SP_cltVpays 'France'

---------- DEMO 2 critres en variables : on rajoute un critre sur l'anne de vente
-----------Dans le select je rajoute mon cdedate
Create procedure SP_cltVpaysVannee (@Pays Varchar(20),@annee int)
as
select clientnom, cdedate from T_Client clt join T_Commande cmd on clt.clientid=cmd.ClientID
where ClientPays= @Pays and year(Cdedate)=@annee

Exec SP_cltVpaysVannee @pays='France', @annee='2004'
Exec SP_cltVpaysVannee 'France', '2004'

----------9.  EXERCICES STAGIAIRES :
--- Je souhaite afficher l'ID session et la date session
-- quand ma date est gale  une variable de type datetime
USe _SQL_SESSION_SIF

Create procedure SP_cltVdate @Date datetime
as
select Session_ID, sessiondate from Session
where sessiondate=@Date

Exec SP_cltVdate @date='10/10/2015'
Exec SP_cltVdate '10/10/2015'

--- 10. Repartir sur la requte prcdente mais rajouter une condition
--- sur le formateur = cration d'une Variable supplmentaire
--- Attention  : besoin de la table formateur
--- Faire une recherche sur le 10 octobre 2015 pour le formateur Ravenne
Create procedure SP_cltVdateVform (@Date datetime,@form varchar(15))
as
select Session_ID, sessiondate from formateur as f join session as s on f.Formateur_ID=s.FormateurID
where sessiondate=@Date and Nom = @form

Exec SP_cltVdateVform @date='10/10/2015', @form='Ravenne'
Exec SP_cltVdateVform '10/10/2015', 'Ravenne'

------------------------- PROCEDURES STOCKEES avec IN ----------
---------- DEMO ------------------
-- Je veux pouvoir slectionner deux mois de commandes !
use comptoir

Create proc cherche_2moisIN (@mois1 int, @mois2 int)
as
select * From T_Commande
where month(cdedate) IN (@mois1,@mois2)

EXEC cherche_2moisIN '1','3'

----- 11. EXERCICES STAGIAIRES :
----- Je souhaite afficher la table catgorie en mettant des variables sur Categorie
----- J'excute avec Beverages et Condiments
create proc cherche_categorieINt (@libc varchar(max),@libd varchar(max))
as
select c.Categorie from T_Categorie c 
where C.Categorie in (@libc,@libd)

EXEC cherche_categorieINt 'Beverages', 'Condiments'

------------------------- PROCEDURES STOCKEES avec LIKE ----------
---------- DEMO ------------------
USE COMPToir 

---------- Je souhaite afficher les catgories qui contiennent
-- Une portion de mot --> Mettre une variable le mot rechercher 'PRO'
create proc cherche_categorie (@libc varchar(max))
as
select c.Categorie from T_Categorie c 
where C.Categorie like '%' + @libc + '%'

EXEC cherche_categorie 'Pro' 

----- 12. EXERCICES STAGIAIRES :
----- Je cherche un theme qui contient des caractres spcifiques en son centre
-- J'excute en testant avec SQL (variable)
USE _SQL_SESSION_SIF

create proc cherche_theme (@libt varchar(max))
as
select theme from theme
where theme like '%' + @libt + '%'

EXEC cherche_theme 'SQL' 
